// Step 1. Import the video library
import processing.video.*;
// Step 2. Declare a Capture object
Capture video;
boolean blacks = false;
boolean edges = false;
boolean blues = false;
boolean reds = false;
float threshold = 100;
void setup() 
{
  size(500,500);
  video = new Capture(this,500,500,5);
}

void draw() {
// Check to see if a new frame is available


if (video.available())
{
    video.read();
}
    loadPixels();
    video.loadPixels();
     if(blacks) black();
    else if(edges) edge();
    else if(blues) blue();
    else if(reds) red();
    for (int x = 0; x < video.width; x ++ ) 
    {
        for (int y = 0; y < video.height; y ++ )
      {
          // calculate the 1D location from a 2D grid
          int loc = x + y*video.width;
          // get the R,G,B values from image
          float r,g,b;
          r = red (video.pixels[loc]);
          g = green (video.pixels[loc]);
          b = blue (video.pixels[loc]);
          // calculate an amount to change brightness based on proximity to the mouse
          float maxdist = 150;// dist(0,0,width,height);
          float d = dist(x,y,mouseX,mouseY);
          float adjustbrightness = (maxdist-d)/maxdist;
          r *= adjustbrightness;
          g *= adjustbrightness;
          b *= adjustbrightness;
          // constrain RGB to make sure they are within 0-255 color range
          r = constrain(r,0,255);
          g = constrain(g,0,255);
          b = constrain(b,0,255);
          // make a new color and set pixel in the window
          color c = color(r,g,b);
          pixels[loc] = c;
        }
    }
    updatePixels();
    
   
   // updatePixels();
    // Display the video image
    //image(video,0,0);

}

void keyPressed()
{
  
  if(key =='b' || key =='B')
    blacks =!blacks;
  else if(key =='e' || key =='E')
    edges =!edges;
  else if(key =='l' || key =='L')
   blues =! blues;
   else if(key =='r' || key =='R')
   reds =! reds;
}

  
  void black()
  {
    float threshold = 100;
    for (int x = 0; x < video.width; x++ ) 
    {
      for (int y = 0; y < video.height; y++ ) 
      {
          int loc = x + y*video.width;
          if (brightness(video.pixels[loc]) > threshold)
          {
            video.pixels[loc] = color(255);
          } 
          else 
          {
            video.pixels[loc] = color(0);
          }
      }
    }
  }
 void edge()
 {
   for (int x = 1; x < width; x++ ) {
    for (int y = 0; y < height; y++ ) {
      
      // Pixel location and color
      int loc = x + y*video.width;
      color pix = video.pixels[loc];
      
      // Pixel to the left location and color
      int leftLoc = (x - 1) + y*video.width;
      color leftPix = video.pixels[leftLoc];
      
      // New color is difference between pixel and left neighbor
      float diff = abs(brightness(pix) - brightness(leftPix));
      video.pixels[loc] = color(diff); 
    }
  }
 }
 
 
 void blue()
  {
    float threshold = 100;
    for (int x = 0; x < video.width; x++ ) 
    {
      for (int y = 0; y < video.height; y++ ) 
      {
          int loc = x + y*video.width;
          if (brightness(video.pixels[loc]) > threshold)
          {
            video.pixels[loc] = color(255);
          } 
          else 
          {
            video.pixels[loc] = color(50,18,228);
          }
      }
    }
  }
 void red()
  {
    float threshold = 100;
    for (int x = 0; x < video.width; x++ ) 
    {
      for (int y = 0; y < video.height; y++ ) 
      {
          int loc = x + y*video.width;
          if (brightness(video.pixels[loc]) > threshold)
          {
            video.pixels[loc] = color(255);
          } 
          else 
          {
            video.pixels[loc] = color(244, 14, 2);
          }
      }
    }
  }
 
